// Charactor.h: CCharactor NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CHARACTOR_H__749C59AF_A3D9_11D2_B316_FEFE7147F708__INCLUDED_)
#define AFX_CHARACTOR_H__749C59AF_A3D9_11D2_B316_FEFE7147F708__INCLUDED_

#include "Vector.h"	// ClassView ɂĒǉ܂B
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "DirectSoundBuffer.h"
#include "DirectDrawSurface.h"
#include "DirectDraw.h"


#define RIGHT		0x0001
#define LEFT		0x0002
#define DUSH		0x0004
#define JUMP		0x0008

class CCharactor  
{
public:
	enum CHARATYPE{DEFAULT,KEY1,KEY2,COM1,COM2,COM3,COM4,COM5,COM6,COM7,COM8};
	static int WhichWin( CCharactor* A,CCharactor* B );
	static void Clip( CCharactor* A , int side );
	static int EarthHeight;
	static RECT FieldRect;
	static CDirectSoundBuffer* pBoon;

	CCharactor();
	virtual ~CCharactor();
	void Init( CHARATYPE DefType,double Speed , double JumpPower , double Gravity , char* pName
				, const char* pBmpName ,CDirectDraw* pDD );
	void CopyInfo( CCharactor* pOther,int side );
	void DrawName( CDirectDrawSurface* pBack,int x,int y);
protected:
	double m_Speed;					// ړXs[h
	double m_Jump;					// Wv
	double m_Gravity;				// d͉x
	char m_Name[255];				// O
	CDirectDrawSurface* m_pSurf;	// G
	CHARATYPE m_DefType;			// ftHg̃Rs[^[[`

public:
	void StartGame( CHARATYPE type , int side );
	void SetPos( CVector& V,int side );
	void Draw( CDirectDrawSurface* pBack,int side);
	void Act(clock_t ms,int side);
	void Think( char* Key,CCharactor* pEnemy,int side);
protected:
	double m_VVelocity[2];			// ݂̉x
	CVector m_Place[2];				// ݂̏ꏊ
	DWORD m_Tactics[2];				// ݂̍
	CHARATYPE m_Type[2];			// ݂̎vl[`
};

#endif // !defined(AFX_CHARACTOR_H__749C59AF_A3D9_11D2_B316_FEFE7147F708__INCLUDED_)
