// Direct3DIM.h: CDirect3DIM NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DIRECT3DIM_H__95A1C640_98DC_11D2_B316_82C6C7937512__INCLUDED_)
#define AFX_DIRECT3DIM_H__95A1C640_98DC_11D2_B316_82C6C7937512__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "DirectDraw.h"
#include "DirectDrawSurface.h"

struct D3DDeviceInfo
{
	D3DCOLORMODEL cm;
	LPGUID pGuid;
	DWORD ZDepth;
	bool bHard;
};

class CDirect3DIM  
{
public:
	CDirect3DIM();
	virtual ~CDirect3DIM();
	bool Initialize( CDirectDraw* pDD , CDirectDrawSurface* pBack );
	void ReleaseAll();

private:
	IDirect3D3* m_pDirect3D;
	IDirect3DDevice3* m_pDirect3DDevice;
	bool m_bInit;
	D3DDeviceInfo m_DevInfo;

	friend class CDirect3DRM;
};


static HRESULT WINAPI D3DEnumDeviceCallBack(
	LPGUID lpGuid, LPSTR lpDeviceDescription, LPSTR lpDeviceName, 
	LPD3DDEVICEDESC lpHWDesc, LPD3DDEVICEDESC lpHELDesc, LPVOID lpContext);

#endif // !defined(AFX_DIRECT3DIM_H__95A1C640_98DC_11D2_B316_82C6C7937512__INCLUDED_)
