// DirectDraw.h: CDirectDraw NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DIRECTDRAW_H__1856BEA8_9276_11D2_B314_AB4C337AF61F__INCLUDED_)
#define AFX_DIRECTDRAW_H__1856BEA8_9276_11D2_B314_AB4C337AF61F__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "DirectDrawSurface.h"

class CDirectDraw  
{
public:
	CDirectDraw();
	virtual ~CDirectDraw();

	bool Initialize( HWND hwnd , int sizeX = 640 , int sizeY = 480 , int BPP = 16 );
	void ReleaseAll();
	void RestoreAll();

	// T[tFXԂ֐Rc
	bool GetBackSurface( CDirectDrawSurface* pS );
	bool CreateSurface(CDirectDrawSurface* pS,int sizeX,int sizeY);
	bool CreateSurface(CDirectDrawSurface* pS,LPCTSTR bmpName);
	bool CreateSurface(CDirectDrawSurface* pS,DDSURFACEDESC2* desc );

	void Flip();

private:
	bool m_bInit;

	IDirectDraw4* m_pDirectDraw;
	IDirectDrawSurface4* m_pPrim;

    DDCAPS m_DriverCaps;
	int m_Bpp;

	friend BOOL CALLBACK DDEnumCallback(GUID FAR* lpGUID, LPSTR lpDriverDesc, LPSTR lpDriverName, LPVOID lpContext);
	friend class CDirect3DRM;
	friend class CDirect3DIM;
};

BOOL CALLBACK DDEnumCallback(GUID FAR* lpGUID, LPSTR lpDriverDesc, LPSTR lpDriverName, LPVOID lpContext);

#endif // !defined(AFX_DIRECTDRAW_H__1856BEA8_9276_11D2_B314_AB4C337AF61F__INCLUDED_)
