// D3DFrame.h: CD3DFrame NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_D3DFRAME_H__407F2C24_94EA_11D2_B316_98C8B9C1384A__INCLUDED_)
#define AFX_D3DFRAME_H__407F2C24_94EA_11D2_B316_98C8B9C1384A__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "D3DMeshBuilder.h"
#include "D3DLight.h"
#include "Vector.h"

class CD3DFrame  
{
public:
	CD3DFrame();
	virtual ~CD3DFrame();
	void Initialize(IDirect3DRMFrame3** ppF);
	void Release();

	void AddMeshBuilder( CD3DMeshBuilder* pM );
	void AddLight( CD3DLight* pL );

	void SetDirection( CD3DFrame* pRef , CVector& dir , CVector& up );
	void SetPosition( CD3DFrame* pRef , CVector& pos );
private:
	IDirect3DRMFrame3* m_pFrame;

	friend class CDirect3DRM;
};

#endif // !defined(AFX_D3DFRAME_H__407F2C24_94EA_11D2_B316_98C8B9C1384A__INCLUDED_)
